#property copyright "Copyright 2010 Wajdyss"
#property link      "wajdyss@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 LawnGreen
#property indicator_color2 Magenta
#property indicator_width1  2
#property indicator_width2  2

extern string Note="Candle=0 -> Current Candle , Candle=1 -> Last Candle";
extern int Candle=0;

extern string Note0="------ MA --------";
extern bool MA=true;
extern int MA_Period = 20;
extern int MA_Shift  = 0;
extern string MA_Method = "0 = Simple, 1 = Exponential, 2 = Smoothed, 3 = Linear Weighted";
extern int MA_method  = 0; 
extern string Apply_to = "0=Close, 1=Open, 2=High, 3=Low, 4=Median, 5=Typical,6=Weighted Close ";
extern int MA_Apply_to = 0;

extern string Note1="------ RSI --------";
extern bool RSI=true;
extern int RSI_Period=14;
extern string RSI_apply_to = "0=Close, 1=Open, 2=High, 3=Low, 4=Median (High+low)/2, 5=Typical (High+low+close)/3,6=Weighted close (High+low+close+close)/4";
extern int RSI_Apply_to =0;
int RSI_Buy_Level=50;
int RSI_Sell_Level=50;

extern string Note2="------ MACD --------";
extern bool MACD=true;
extern int MACD_Fast_EMA = 12;
extern int MACD_Slow_EMA = 26;
extern int MACD_SMA = 9;
extern string MACD_Apply_to_Note = "0=Close , 1=Open 2=High , 3=Low , 4=Median Price(high+low)/2 , 5=Typical Price(high+low+close)/3 , 6=Weighted close Price(high+low+close+close)/4";
extern int MACD_Apply_to= 0;

extern string Note3="------ Bollinger Bands 1 --------";
extern bool BB1=true;
extern int  BB1_Period=10;
extern int  BB1_Shift=0;
extern int  BB1_deviations=2;
extern string BB1_Apply_to_Note="0=Close, 1=Open, 2=High, 3=Low, 4=Median, 5=Typical,6=Weighted Close ";
extern int  BB1_Apply_to=0;

extern string Note4="------ Bollinger Bands --------";
extern bool BB2=true;
extern int  BB2_Period=20;
extern int  BB2_Shift=0;
extern int  BB2_deviations=2;
extern string BB2_Apply_to_Note="0=Close, 1=Open, 2=High, 3=Low, 4=Median, 5=Typical,6=Weighted Close ";
extern int  BB2_Apply_to=0;

extern string Note5="   ";
extern int Pips=20;

extern string Note6="-----------------";
extern bool alert = true;

extern string Note7="-----------------";
extern int TextSize=14;
extern color TextColor1=Black;
extern color TextColor2=Red;
extern color TextColor3=Blue;
extern color TextColor4=Black;
extern color TextColor5=Black;

bool manual=true;
int w=0,ww=0;
double CrossUp[];
double CrossDown[];
int eyear=9999;
int emonth=9;
int eday=9;
bool al1=false;
bool al2=false;
int MA_Buy=1;
int j1,j2;
string Name="wajdyss 2MA RSI MACD BB Indicators";
string hname;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0, DRAW_ARROW, EMPTY);
   SetIndexArrow(0, 233);
   SetIndexBuffer(0, CrossUp);
   SetIndexStyle(1, DRAW_ARROW, EMPTY);
   SetIndexArrow(1, 234);
   SetIndexBuffer(1, CrossDown);
//----
  //a

   {
      ObjectCreate("a label", OBJ_LABEL, 0,0,0);
      ObjectSetText("a label","   " , TextSize, "Arial", TextColor1);
      ObjectSet("a label", OBJPROP_XDISTANCE,350);
     ObjectSet("a label", OBJPROP_YDISTANCE,0);
   }
   
   //b
      
   {
      ObjectCreate("b label", OBJ_LABEL, 0,0,0);
      ObjectSetText("b label",Name , TextSize, "Arial", TextColor2);
      ObjectSet("b label", OBJPROP_XDISTANCE,290);
     ObjectSet("b label", OBJPROP_YDISTANCE,25);
   }
   
   // c

   
   {
      ObjectCreate("c label", OBJ_LABEL, 0,0,0);
      ObjectSetText("c label","wajdyss@yahoo.com"  , TextSize, "Arial", TextColor3);
      ObjectSet("c label", OBJPROP_XDISTANCE,335);
     ObjectSet("c label", OBJPROP_YDISTANCE,50);
   }

   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  Comment("");
 ObjectDelete("a label");
 ObjectDelete("b label");
 ObjectDelete("c label");
 ObjectDelete("d label");
 ObjectDelete("e label");
  ObjectsDeleteAll(0,OBJ_TEXT);


   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   
    if ((Year()>eyear) || (Year()==eyear && Month()>emonth) || (Year()==eyear && Month()==emonth && Day()>eday))
    {
       //d

   {
      ObjectCreate("d label", OBJ_LABEL, 0,0,0);
      ObjectSetText("d label","the indicator has expired , contact us by E-mail" ,TextSize, "Arial", TextColor4);
      ObjectSet("d label", OBJPROP_XDISTANCE,250);
     ObjectSet("d label", OBJPROP_YDISTANCE,75);
   }
      return(0);
    } 
   else 
   {
      ObjectCreate("d label", OBJ_LABEL, 0,0,0);
      ObjectSetText("d label","http://forum.m-e-c.biz",TextSize, "Arial", TextColor4);
      ObjectSet("d label", OBJPROP_XDISTANCE,335);
     ObjectSet("d label", OBJPROP_YDISTANCE,75);
   }
      
   int  same , notsame, samef, notsamef, samer, notsamer, samecandle, notsamecandle ;
   double  GSignalUP=0 , SignalUP=0 , GSignalDOWN=0, SignalDOWN=0 , AllSignal=0 , BSignalUP=0
    , BSignalDOWN=0 ,a ;
   
   double samep,notsamep,all,GSignals,GSignalsP, GSignalUPP,GSignalDOWNP,FRMA1,FRMA2,FMA1,FMA2,SMA1,SMA2,FMA11,FMA22,SMA11,SMA22;
   string sameforecast,notsameforecast, wajdyssforecast , status ;



   int up=0;

   for (int i=Bars;i>=Candle;i--) 
   { 

    FMA1=iMA(Symbol(), 0, MA_Period, MA_Shift, MA_method, MA_Apply_to, i);

    double rsi=iRSI(Symbol(),0,RSI_Period,RSI_Apply_to,i);

    bool macd_up=false;
    bool macd_down=false;
    
    double macd1=iMACD(Symbol(), 0, MACD_Fast_EMA, MACD_Slow_EMA, MACD_SMA , MACD_Apply_to , MODE_MAIN, i);
    double macd2=iMACD(Symbol(), 0, MACD_Fast_EMA, MACD_Slow_EMA, MACD_SMA , MACD_Apply_to , MODE_SIGNAL, i);
    
    if (macd1>macd2) macd_up=true; else macd_up=false;
    if (macd1<macd2) macd_down=true; else macd_down=false;
    
    double BB1_Up=iBands(Symbol(),0,BB1_Period,BB1_deviations,BB1_Shift,BB1_Apply_to,1,i);   
    double BB1_Down=iBands(Symbol(),0,BB1_Period,BB1_deviations,BB1_Shift,BB1_Apply_to,2,i);   
    bool bb11=false;
    bool bb12=false;
    
    double BB2_Up=iBands(Symbol(),0,BB2_Period,BB2_deviations,BB2_Shift,BB2_Apply_to,1,i);   
    double BB2_Down=iBands(Symbol(),0,BB2_Period,BB2_deviations,BB2_Shift,BB2_Apply_to,2,i);   
    bool bb21=false;
    bool bb22=false;

    if (BB1_Up>BB2_Up) bb11=true; else bb11=false; 
    if (BB1_Down<BB2_Down) bb12=true; else bb12=false; 

    // if (BB2_Up>BB2_Up) bb21=true; else bb21=false; 
    //if (Close[i]<=BB2_Down) bb22=true; else bb22=false; 
    
      hname="h"+i;
    string Name2=DoubleToStr(Close[i],Digits);
    if (!MA) {FMA1 = -1;}
    if (!RSI) {RSI_Buy_Level = 0;}
    if (!MACD) {macd_up = true;}
    if (!BB1) {bb11 = true;}
//    if (!BB2) {bb21 = true;}

    if  (MA_Buy==-1 && rsi > RSI_Buy_Level && macd_up && bb11 && Close[i]>FMA1)


   {
   CrossUp[i] = Low[i]-Pips*Point;
   AllSignal++;
   SignalUP++;
   up=1;
   j1=i;
   MA_Buy=1;

   SetText(hname,Name2,Time[i],(Low[i]-Pips*2*Point),"Arial",8,TextColor5);

   if (iClose(Symbol(),NULL,i-1)>iOpen(Symbol(),NULL,i-1))
   GSignalUP++;
   else BSignalUP++;
   }
 
    if (!MA) {FMA1 = 9999999999 ;}
    if (!RSI) RSI_Sell_Level = 100;
    if (!MACD) {macd_down = true;}
    if (!BB1) {bb12 = true;}
//    if (!BB2) {bb22 = true;}

    
    if  ( MA_Buy==1 && rsi < RSI_Sell_Level && macd_down && bb12 && Close[i]<FMA1)
   { 
    CrossDown[i] = High[i]+Pips*Point;
      AllSignal++;
      SignalDOWN++;
   up=-1;
   j2=i;
   MA_Buy=-1;
      SetText(hname,Name2,Time[i],(High[i]+Pips*3*Point),"Arial",8,TextColor5);

   if (iClose(Symbol(),NULL,i-1)<iOpen(Symbol(),NULL,i-1))
    GSignalDOWN++;
   else BSignalDOWN++;
   }
}
GSignals=GSignalUP+GSignalDOWN;
GSignalsP=GSignals/AllSignal;
GSignalUPP=(GSignalUP/SignalUP);
GSignalDOWNP=(GSignalDOWN/SignalDOWN);
 

i=1;   

     if (CrossUp[i]!=EMPTY_VALUE && alert==true) {al1=false; if (al2==false) { Alert (Name," Symbol ",Symbol()," Time Frame  ",Period()," Close Sell Orders And Buy AT ",Close[j1]);  al2=true;}}

     if (CrossDown[i]!=EMPTY_VALUE && alert==true){al2=false; if (al1==false) { Alert (Name," Symbol ",Symbol()," Time Frame  ",Period()," Close Buy Orders And Sell AT ",Close[j2]);  al1=true;}}

   return(0);
  }

void SetText(string name,string txt,datetime x,double y,string font,int size,color clr)
{
  int idx=0;
  if(ObjectFind(name) == -1)
  {
    ObjectCreate(name, OBJ_TEXT, idx, 0, 0);
    ObjectSetText(name, txt, size, font, clr);
    ObjectSet(name, OBJPROP_TIME1, x);
    ObjectSet(name, OBJPROP_PRICE1, y);
  }
  else
  {
    ObjectSet(name, OBJPROP_TIME1, x);
    ObjectSet(name, OBJPROP_PRICE1, y);
    ObjectSetText(name, txt, size, font, clr);
  } 
}